require 'remi-signer'

RSpec.describe RemiSigner do
  let(:signer) { RemiSigner.new("test-secret") }

  describe "#sign" do
    it "treats empty array as nil" do
      sig1 = signer.sign(a: 1, b: [], c: 2)
      sig2 = signer.sign(a: 1, b: nil, c: 2)
      expect(sig1).to eq sig2
    end
  end

  describe ".stringize" do
    it "convert array correctly" do
      expect(RemiSigner.stringize(a: 1, b: [], c: 2)).to eq "a=1&b=&c=2"
      expect(RemiSigner.stringize(a: 1, b: { c: 2, d: 3 }, e: [1,2])).to eq "a=1&b=c=2&d=3&e=1,2"
      e = [{
        f: 1,
        g: 2
      },3]
      expect(RemiSigner.stringize(a: 1, b: { c: 2, d: 3 }, e: e)).to eq "a=1&b=c=2&d=3&e=f=1&g=2,3"
    end
  end
end

